对一个可枚举的对象集合进行去重操作时，一般第一个想到的就是就是Linq的Distinct方法。
> Enumerable.Distinct 方法
 
 是常用的LINQ扩展方法，属于System.Linq的Enumerable方法，可用于去除数组、集合中的重复元素，还可以自定义去重的规则。
 > 值类型元素集合去重
 - List<int> list = new List<int> { 1, 1, 2, 2, 3, 4, 5, 5 };
list.Distinct().ToList().ForEach(s => Console.WriteLine(s));执行结果：12345

-  Distinct()方法的返回集合类型是一个接口，不是具体的集合，所以需要用一个ToList()。

我们对对象集合使用Distinct方法时要使用重载Distinct<TSource>(this IEnumerable<TSource> source, IEqualityComparer<TSource> comparer);

要使用这个方法，我们得重写IEqualityComparer接口，再使用Distinct方法