> 什么是需求文档

需求的定义包括从用户角度(系统的外部行为)，以及从开发者角度(一些内部特性)来阐述需求。
分析就是一个决策的过程，基于公司战略背景、产品所处阶段等现实因素，对收集的需求进行分类、定位、确定优先级，决定哪些做，哪些不做，哪些先做，哪些后做，并整理出可执行的产品迭代规划。
文档就是把需求分析整理归纳，用于组内成员，用户和开发者共同规划。


> 需求文档的重要性

- 如果没有需求文档，在一个项目中途更换了所有的开发者，难道需要客户再一次向新的开发者谈需求吗，现在客户要的就是给他编一个系统。这样新的分析人员不得不从头做起。所以如果只有一堆邮件、会谈记录或一些零碎的未整理的对话，你就确信你已明白用户的需求，那完全是自欺欺人。
- 从开发团内内部来说：开发软件系统最为困难的部分就是准确说明开发什么。最为困难的概念性工作便是编写出详细技术需求，这包括所有面向用户、面向机器和其它软件系统的接口。同时这也是一旦做错，将最终会给系统带来极大损害的部分，并且以后再对它进行修改也极为困难。
- 即便并非出于商业目的的软件需求也是必须的。例如库、组件和工具这些供开发小组内部使用的软件。当然你可能偶尔勿需文档说明就能与其他人意见较为一致，**需求文档更重要的是出现重复返工这种不可避免的后果**，而重新编制代码的代价远远超过重写一份需求文档的代价，这些血的教训正在国内的软件开发者身上发生。


所以说，**需求文档在开发过程中一直起指导作用，一张清晰明确的需求清单是非常有用的**，他能最大程度地避免错误的发生，减少损失。开发者依据需求对系统进行测试时，此系统不仅非常清晰地实现了所有必需功能，而且未发现任何错误。



```
下回解说如何进行需求分析，需求分析的流程
```
