> 枚举

- 枚举类型声明为一组相关的符号常数定义了一个类型名称。
- 枚举用于“多项选择”场合，就是程序运行时从编译时已经设定的固定数目的“选择”中做出决定。

> 枚举中有两个很实用的方法
- 1、GetHashCode():返回该实例的值的哈希代码
- 2、ToString() :将此实例的值转换为其等效的字符串表示

> 枚举特点

- 枚举使用enum关键字来声明，与类同级。枚举可以和类并列也可以写在类里面，不能写在方法里。
- 枚举是值类型，隐式继承自System.Enum，不能手动修改。System.Enum本身是引用类型，继承自System.ValueType。
- 枚举本身一般不加访问修饰符，要加的话只能是internal 或public;
- 枚举都是隐式密封的(sealed)，不允许作为基类派生子类。
- 每种枚举类型都有基础类型，该类型可以是任何整型, 枚举元素 的默认基础类型为 int。
  - 默认情况下，第一个枚举数的值为 0，后面每个枚举数的值依次递增 1。
  - 枚举数可以具有重写默认值的初始值设定项。但是，强烈建议枚举包含一个值为 0 的常量。
  - 枚举元素不可以重复，枚举元素的值可以重复。
  - 枚举数的名称中不能包含空白。
- 最后一个元素后的逗号可有可无。枚举最后的冒号可有可无。
- 枚举里面的成员只能是默认公共的静态的(public、static)，不能有访问修饰符;